<HTML>
<BODY>
<TITLE>Exemple de communication avec serveur IACA en ASP</TITLE>
<CENTER>
<H3>Utilisation de ASP pour communiquer avec le service IACA</H3>
</CENTER>
<HR>
<%
////////////////////////////////////////////////////////////////////////////
// Server.CreateObject("TCPComIACA.ClasseTCPComIACA") retourne un objet.
// Dans l'exemple, il a t nomm TCPComIACAObj mais vous pouvez utiliser un
// autre nom.
// Cette instruction utilise le fichier TCPComIACA.dll que vous trouverez sur
// le site de iaca dans les outils divers.
// TCPComIACA.dll est  mettre sur le serveur o asp est utilis et doit tre
// enregistr (rfrenc) avec regsvr32.exe.
// L'objet TCPComIACAObj peut ensuite tre utilis pour communiquer avec le
// serveur IACA.
// La premire chose  faire avec TCPComIACAObj est d'appeler Interroge.
// Interroge a besoin de trois paramtres :
// - L'adresse IP du serveur IACA (une chane)
// - Le numro du port utilis par le service IACA. Soit le nombre 5016.
// - La commande  passer (une chane).
// Par exemple
// TCPComIACAObj.interroge "172.16.0.1",5016,"NU=DUCHEF|GETMDP"
// demande au serveur IACA de retourner le mot de passe de DUCHEF
////////////////////////////////////////////////////////////////////////////
// Demande le mot de passe de DUCHEF
// Syntaxe de la chane  envoyer :
// NU=DUCHEF|GETMDP
// Majuscules et minuscules sont indiffrentes
// Le nom doit correspond au nom de login
// Retours possibles :
// NU=DUCHEF|GETMDP=12345 (retourne le mot de passe)
// NU=DUCHEF|GETMDP=      (indique que le mot de passe est vide)
// NU=DUCHEF|GETMDP=************** (14 toiles=secret)
// NU=DUCHEF|GETMDP_ERR=2 (indique une erreur)
// 2 : non trouv ; 5 : non autoris
// 12 : accs invalide ; 87 : paramtre incorrect
// etc.
////////////////////////////////////////////////////////////////////////////
// Impose le mot de passe abcd pour DUCHEF
// Syntaxe de la chane  envoyer :
// NU=DUCHEF|MDP=abcd
// Majuscules et minuscules sont indiffrentes sauf pour le mot de passe.
// le nom doit correspond au nom de login
// Retours possibles :
// NU=DUCHEF|MDP_OK (Changement effectu)
// NU=DUCHEF|MDP_ERR=2 (indique une erreur)
// 2 : non trouv ; 5 : non autoris
// 12 : accs invalide ; 87 : paramtre incorrect
// 1325 : mot de passe trop simple. Refus par AD
// etc.
// Cas particulier permettant de rendre le mot de passe secret sans le 
// changer :
// NU=DUCHEF|MDP=************** (14 toiles)
// L'administrateur ne verra plus le mot de passe.
// Il ne pourra supprimer son caractre secret qu'en
// imposant un nouveau mot de passe dans IACA.
////////////////////////////////////////////////////////////////////////////

// Corrigez la valeur de IPServeurIACA en indiquant l'adresse IP relle de
// votre serveur IACA

      IPServeurIACA="192.168.1.2"

// Ne changez pas le numro du port.

      LePort=5016

// Cration de l'objet

   Set TCPComIACAObj = Server.CreateObject("TCPComIACA.ClasseTCPComIACA") 

// Demande  envoyer

   TCPComIACAObj.Interroge IPServeurIACA,LePort,"NU=DUCHEF|GETMDP"

/////////////////////////////////////////////////
// La variable REPONSE peut tre traite, dcoupe...
// Dans cet exemple elle est affiche puis dcoupe.
/////////////////////////////////////////////////

   response.write "Adresse IP du serveur IACA : " & IPServeurIACA & "<BR>"
   response.write "REPONSE : " & TCPComIACAObj.Reponse & "<BR>"  

   Morceaux = Split(TCPComIACAObj.Reponse,"|" )
   // Split permet de dcouper une chane en indiquant le sparateur
   // Si TCPComIACAObj.Reponse vaut NU=DUCHEF|GETMDP=123 alors Morceaux
   // devient un tableau de deux chanes (indices 0 et 1) avec Morceaux(0)
   // qui vaut NU=DUCHEF et Morceaux(1) qui vaut GETMDP=123 
   if ubound(Morceaux)=1 then
      MorceauxNom = Split(Morceaux(0),"=")
      if ubound(MorceauxNom) = 1 then
         Nom = MorceauxNom(1)
      End if
      MorceauxResultat = Split(Morceaux(1),"=")
      if ubound(MorceauxResultat)=1 then
         Resultat=MorceauxResultat(0)
         Mdp=MorceauxResultat(1)
      End if
      response.Write "Nom de l'utilisateur : " & Nom & "<br>"
      response.Write "Rsultat : " & Resultat & "<br>"  
      response.Write "Mot de passe ou code erreur : " & Mdp & "<br>"  
   else
      response.Write "Erreur<br>"  
   End if

%>
<HR>
</BODY>
</HTML>